//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//
// A driver program for the Shape/ShapeBasics/Position/PositionBasics
//   PositionalShape/PositionalShapeBasics/Circle/Rectangle classes.
//
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////


import java.awt.Point;
import edu.cmu.cs.pattis.cs151xx.Prompt;



public class Application {

  private static PositionalShape[] shapes = new PositionalShape[6];
  
  
  private static char menuPrompt () 
  {
    System.out.println("\n\nMutators          Accessors           General");
    System.out.println("  c - construct     o - mayOverlap      d - display");
    System.out.println("  m - moveTo                            q - quit");
    System.out.println("  M - moveBy");
    System.out.println("  C - change info");
    return Prompt.forChar("\nEnter Command","cmMCRodq");
  }
  
  
  
  private static void display()
  {
    System.out.println("\nIndex Information");  
    for (int i=0; i<shapes.length; i++)
      System.out.println("  shapes["+i+"] = " + shapes[i]);
  }
  
  
  private static PositionalShape get()
  {
    char selection = Prompt.forChar("Enter type of Shape: [c]ircle or [r]rectangle","cr");  
    PositionalShape answer;
    if (selection == 'c')
      answer = new Circle("",0,0,0);
    else
      answer = new Rectangle("",0,0,0,0);
    answer.promptForInformation();
    return answer;
  }
  
  
  
  //////////
  // Main
  //////////
  
	public static void main(String[] args)
	{
	  display();
	  for (;;)
	    try {
  	    char selection = menuPrompt();

        if (selection == 'c') {
  	      int index = Prompt.forInt("Enter index of object to process",0,shapes.length-1);
          shapes[index] = get();
          
        }else if (selection == 'm') {
  	      int index = Prompt.forInt("Enter index of object to process",0,shapes.length-1);
          int newX  = Prompt.forInt("  Enter new x coordinate");
          int newY  = Prompt.forInt("  Enter new y coordinate");
          shapes[index].moveCenterTo( new Point(newX,newY) );
                     
        }else if (selection == 'M') {
  	      int index = Prompt.forInt("Enter index of object to process",0,shapes.length-1);
          int newX  = Prompt.forInt("  Enter dx coordinate");
          int newY  = Prompt.forInt("  Enter dy coordinate");
          shapes[index].moveCenterBy(newX,newY);
                     
        }else if (selection == 'C') {
  	      int index = Prompt.forInt("Enter index of object to process",0,shapes.length-1);
          //shapes[index].promptForInformation();
                      
        }else if (selection == 'o') {
  	      int index      = Prompt.forInt("Enter index of object to process",0,shapes.length-1);
          int otherIndex = Prompt.forInt("  Enter other index of object to process",0,shapes.length-1);
          System.out.println("mayOverlap = " + shapes[index].mayOverlap(shapes[otherIndex]));
                                 
        }else if (selection == 'd')
          display();
         
        else if (selection == 'q')
           break;

  	    else
  	      System.out.println("Unknown command");

  		}catch (Exception e) {
        System.out.println("  Exception Caught/Handled: "+e.getClass().getName());
        if (e.getMessage() != null)
          System.out.println(e.getMessage());
  	  }
  }
}


