import java.awt.Point;
import java.awt.Rectangle;


public abstract class PositionalShapeBasics implements PositionalShape {

  public PositionalShapeBasics (String name, int centerX, int centerY)
    { 
      s  = new ShapeBasics(name);
      p  = new PositionBasics(centerX,centerY);
    }
    
    public abstract double    getArea();
    public abstract Rectangle getBoundingBox();
    
    public void promptForShapeInformation()
    {s.promptForShapeInformation();}

    public void promptForPositionInformation()
    {p.promptForPositionInformation();}

    public void promptForInformation()
    {
      promptForShapeInformation();
      promptForPositionInformation();
    }
    
    
    public String getId()
    {return s.getId();}
    
    public double distanceTo(Position other)
    {return p.distanceTo(other);}
    
    public Point getCenter()
    {return p.getCenter();}
    
    public void moveCenterTo(Point newCenter)
    {p.moveCenterTo(newCenter);}
    
    public void moveCenterBy(int dx, int dy)
    {p.moveCenterBy(dx,dy);}
    
    public boolean mayOverlap(PositionalShape other)
    {return getBoundingBox().intersects(other.getBoundingBox());}
    
    public String toString( )
    {return "PositionalShapeBasics[s="+s+",p="+p+"]";}


    //Fields
    private ShapeBasics    s;
    private PositionBasics p;
}
